Main Page | Modules | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | Related Pages

# SoFile Class Reference
[Nodes]

`#include <Inventor/nodes/SoFile.h>`

Inheritance diagram for SoFile:

List of all members.

## Detailed Description

The SoFile class is node container for another model file.

This node provides a way to split your models into a set of "component" models to include into larger "master" files.

Just provide the name of the model file to include in the SoFile::name field, and it will automatically be loaded and have its nodes inserted into the scenegraph at the point of the SoFile node.

You can also set the SoFile::name field manually. Such an action will then automatically trigger an invocation of a read operation which imports the filename you set in the field.

## Public Member Functions
| SoFile (void)
virtual void | doAction (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
SoGroup * | copyChildren (void) const
virtual SoChildList * | getChildren (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
const SbString & | getFullName (void) const
## Static Public Member Functions
void | initClass (void)
## Public Attributes
SoSFString | name
## Protected Member Functions
virtual | ~SoFile ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual SbBool | readNamedFile (SoInput *in)

## Constructor & Destructor Documentation

SoFile::SoFile | ( | void |  | ) |

| Constructor.

SoFile::~SoFile | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoFile::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoNode.

void SoFile::doAction | ( | SoAction * | action | ) | `[virtual]`

| This function performs the typical operation of a node for any action. Reimplemented from SoNode.

void SoFile::callback | ( | SoCallbackAction * | action | ) | `[virtual]`

| Action method for SoCallbackAction. Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph. Reimplemented from SoNode.

void SoFile::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoNode.

void SoFile::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) | `[virtual]`

| Action method for the SoGetBoundingBoxAction. Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node. Nodes influencing how geometry nodes calculates their bounding box also overrides this method to change the relevant state variables. Reimplemented from SoNode.

void SoFile::getMatrix | ( | SoGetMatrixAction * | action | ) | `[virtual]`

| Action method for SoGetMatrixAction. Updates action by accumulating with the transformation matrix of this node (if any). Reimplemented from SoNode.

void SoFile::handleEvent | ( | SoHandleEventAction * | action | ) | `[virtual]`

| Action method for SoHandleEventAction. Inspects the event data from action, and processes it if it is something which this node should react to. Nodes influencing relevant state variables for how event handling is done also overrides this method. Reimplemented from SoNode.

void SoFile::pick | ( | SoPickAction * | action | ) | `[virtual]`

| Action method for SoPickAction. Does common processing for SoPickAction action instances. Reimplemented from SoNode.

void SoFile::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoNode.

void SoFile::audioRender | ( | SoAudioRenderAction * | action | ) | `[virtual]`

| Action method for SoAudioRenderAction. Does common processing for SoAudioRenderAction action instances. Reimplemented from SoNode.

SoGroup * SoFile::copyChildren | ( | void |  | ) | const

| Returns a subgraph with a deep copy of the children of this node.

SoChildList * SoFile::getChildren | ( | void |  | ) | const`[virtual]`

| Returns list of children for this node. Reimplemented from SoNode.

void SoFile::copyContents | ( | const SoFieldContainer * | from,
|  | SbBool | copyconnections
| ) | `[virtual]`

| Makes a deep copy of all data of from into this instance, except external scenegraph references if copyconnections is `FALSE`. This is the protected method that should be overridden by extension node / engine / dragger / whatever subclasses which needs to account for internal data that are not handled automatically. Note that for simply copying e.g. a node from application code, it should be sufficient to do:
      SoNode * mynewnode = templatenode->copy();
Make sure that when you override the copyContents() method in your extension class that you also make it call upwards to it's parent superclass in the inheritance hierarchy, as copyContents() in for instance SoNode and SoFieldContainer does important work. It should go something like this:
      void
      MyCoinExtensionNode::copyContents(const SoFieldContainer * from,
                                        SbBool copyconnections)
      {
        // let parent superclasses do their thing (copy fields, copy
        // instance name, etc etc)
        SoNode::copyContents(from, copyconnections);

        // [..then copy internal data..]
      }
Reimplemented from SoNode.

const SbString & SoFile::getFullName | ( | void |  | ) | const

| Returns the read filename, possibly including the (relative) path where the file was found. Returns an empty string if no file has been read. This method is an extension versus the Open Inventor API.

SbBool SoFile::readInstance | ( | SoInput * | in,
|  | unsigned short | flags
| ) | `[protected, virtual]`

| This method is mainly intended for internal use during file import operations. It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistant representation of an instance of this class type. `TRUE` or `FALSE` is returned, depending on if the instantiation and configuration of the new object of this class type went ok or not. The import process should be robust and handle corrupted input streams by returning `FALSE`. flags is used internally during binary import when reading user extension nodes, group nodes or engines. Reimplemented from SoNode.

SbBool SoFile::readNamedFile | ( | SoInput * | in | ) | `[protected, virtual]`

| Read the file named in the SoFile::name field. Used to be a private method, moved into protected space to enable subclasses to detect when the file is (re)read. Since: Coin 2.0

## Member Data Documentation

SoSFString SoFile::name

| Filename for model file to insert in the scenegraph at the location of the SoFile node.

The documentation for this class was generated from the following files:

- SoFile.h
- SoFile.cpp